package Msn::Bot::Dict;

# $Id: Dict.pm 28 2004-03-20 04:56:41Z tea $

use strict;
use warnings;
use Carp;

use Net::Dict;
use constant DICT_SERVER => 'dict.org';

use URI;
use URI::Escape;
use HTTP::Request;
use LWP::UserAgent;
use constant JEDI_URI => 'http://poets.notredame.ac.jp/cgi-bin/jedi';

# TODO
# There are many LWP::UserAgent instance
# and It's similar code with Msn::Bot::Translate.
my $userAgent = LWP::UserAgent->new();


sub jedi {
    my ($word, $convertIn, $convertOut) = @_;
    my $request = HTTP::Request->new(POST => JEDI_URI);

    $request->push_header("Host", URI->new(JEDI_URI)->host);
    $request->content(
        sprintf("item=%s&convertin=%s&convertout=%s&dictionary=edict",
            uri_escape($word), $convertIn, $convertOut
        )
    );

    my $response = $userAgent->request($request);
    if ($response->is_success) {
        # XXX dirty code
        my $body = $response->content;
        if ($body =~ m{^(\[$word\].+)\<br\>[\r\n]*$}im) {
            return "$1\r\n";
        }
    }
    return undef;
}

sub define {
    my $word = shift(@_);
    my $dict = Net::Dict->new(DICT_SERVER);
    my $result = "";
    
    for (@{$dict->define($word)}) {
        last if length($result) + length($_->[1]) > 1024;
        $result .= $_->[1] . "\r\n";
    }
    
    return $result;
}

1;
