package Msn::Bot::Google;

# $Id: Google.pm 28 2004-03-20 04:56:41Z tea $

use strict;
use warnings;
use Carp;
use Encode qw/from_to/;

use Net::Google;
use constant GOOGLE_LICENSE_KEY => $ENV{GOOGLE_KEY};

my $google = Net::Google->new(key => GOOGLE_LICENSE_KEY);

sub search {
    my (@words) = @_;
    my $search = $google->search();

    $search->query(@words);
    $search->lr(qw/en ja/);
    $search->starts_at(0);
    $search->max_results(6);
    
    my $result = join("\n", map {
        my $title = $_->title(); $title =~ s{<.+?>}{}g;
        sprintf("%s (%s)", $title, $_->URL());
    } @{$search->results()});

    # XXX
    # This is hardcoding the charset.
    # from_to($result, "shiftjis", "utf8");

    # XXX
    # Error when I use SEARCH command with site:jp param,
    # perhaps, It return japanese encoding result.
    # I need to encode that.

    return $result;
}

sub spelling {
    my ($word) = @_;

    # TODO
    # suggest() return nothing when the phrase is correct spelling.
    return $google->spelling(phrase => $word)->suggest();
}


1;

