package Msn::Message::MSNSLP;

# $Id: MSNSLP.pm 31 2004-03-21 11:21:26Z tea $

# XXX state of this module:  NO TESTED

use strict;
use warnings;
use Carp;

use Msn::Util::MIME;

use constant T_SESSIONCLOSEBODY => 'application/x-msnmsgr-sessionclosebody';
use constant T_SESSIONREQBODY => 'application/x-msnmsgr-sessionreqbody';
use constant T_TRANSREQBODY => 'application/x-msnmsgr-transreqbody';

sub new {
    my ($class) = @_;
    my $self = bless({}, $class);

    $self->{status} = "";
    $self->{header} = Msn::Util::MIME->new();
    $self->{body}   = Msn::Util::MIME->new();

    $self;
}

sub setParam {
    my ($self, $method, $toAddress, $fromAddress, $branchUid, $cseq, $uid,
        $maxForwards, $contentType, @param) = @_;
        
    # set status line
    if ($method eq 'INVITE' or 'BYE') {
        $self->{status} = "$method MSNMSGR: $toAddress MSNSLP/1.0";
    }
    elsif ($method eq 'DECLARE') {
        $self->{status} = "MSNSLP/1.0 603 DECLARE";
    }
    elsif ($method eq 'OK') {
        $self->{status} = "MSNSLP/1.0 200 OK";
    }
    else {
        croak "Unknown SLP method: $method\n";
    }

    # set body
    if ($method eq 'INVITE') {
        if ($contentType) {
            $self->{header}->setHeader('Bridges',      $param[0]);
            $self->{header}->setHeader('NetID',        $param[1]);
            $self->{header}->setHeader('Conn-Type',    $param[2]);
            $self->{header}->setHeader('UPnPNat',      $param[3]);
            $self->{header}->setHeader('ICF',          $param[4]);
        }
        else {
            $self->{header}->setHeader('EUF-GUID',     $param[0]);
            $self->{header}->setHeader('SessionID',    $param[0]);
            $self->{header}->setHeader('AppID',        $param[0]);
            $self->{header}->setHeader('Context',      $param[0]);
        }
    }
    elsif ($method eq 'OK') {
        if ($contentType) {
            # TODO
            # Not sure what to do.
            croak "Not sure what to do ...";
        }
        else {
            $self->{message}->setHeader('SessionID', $param[0]);
        }
    }
    elsif ($method eq 'DECLARE') {
        $self->{message}->setHeader('SessionID', $param[0]);
    }

    $self->{body}->setHeader('To',   qq(<msnmsgr:$toAddress>));
    $self->{body}->setHeader('From', qq(<msnmsgr:$fromAddress>));
    $self->{body}->setHeader('Via',  qq(MSNSLP/1.0/TLP ;branch={$branchUid}));
    $self->{body}->setHeader('CSeq',         $cseq);
    $self->{body}->setHeader('Call-ID',      $uid);
    $self->{body}->setHeader('Max-Forwards', $maxForwards);

    if ($method eq 'BYE') {
        $self->{body}->setHeader('Content-Type', T_SESSIONCLOSEBODY);
    }
    else {
        if ($contentType) {
            $self->{body}->setHeader('Content-Type', T_TRANSREQBODY);
        }
        else {
            $self->{body}->setHeader('Content-Type', T_SESSIONREQBODY);
        }
    }

    # TODO Content-Length will be add when make the chunk.
    
    $self;
}

sub makePacket {
    my ($self) = @_;

    # TODO
    return "";
}


1;

