package Msn::Util::MIME;

# $Id: MIME.pm 32 2004-03-21 22:14:30Z tea $

use strict;
use warnings;
use Carp;

use Msn::Util::UserHash;

sub new {
    my ($class) = shift(@_);
    my $self = bless({}, $class);

    $self->{header} = Msn::Util::UserHash->new();

    if (defined $_[0]) {
        if (ref $_[0] eq 'HASH') { 
            foreach (keys %{$_[0]}) {
                $self->setHeader($_, $_[0][$_]);
            }
        }
    }

    $self;
}

sub setHeader {
    my ($self, $key, $value) = @_;

    $self->{header}->add($key, $value);
}

sub getHeader {
    my ($self, $key) = @_;

    $self->{header}->get($key);
}

sub setBody {
    my ($self, $body) = @_;
    $self->{body} = $body;
}

sub getBody {
    my ($self) = @_;
    return $self->{body} || '';
}

sub getHeaderKeys {
    my ($self) = @_;
    return $self->{header}->keys();
}

sub makeHeader {
    my ($self) = @_;
    return  join("\r\n",
                map{
                    "$_: ".$self->getHeader($_)
                } $self->getHeaderKeys()
            );
}

1;

